% DST_III by means of DCT_IV

% Markus P?schel, Jos? MF Moura. The Algebraic Approach to the Discrete
% Cosine and Sine Transforms and their Fast Algorithms SIAM Journal of
% Computing 2003, Vol. 32, No. 5, pp. 1280-1316.


% signal to be transformed
N=16;
k=0:N-1;
x=randn(1,N);

% original DST_III matrix
DCT3=cos(pi/N*[(0:N-1)+1/2]'*[(0:N-1)]);

% true result
y=x*DCT3

% DCT_IV matrix
DCT4=cos(pi/N*[(0:N-1)+1/2]'*[(0:N-1)+1/2]);

%%% algorithm %%%
D=diag(1./[cos((k+1/2)*pi/(2*N))]);
B=diag(ones(1,N-1),1)+eye(N);
B(1,1)=2;
B=B/2;

y1=x*D*DCT4*B
